'use strict';

var _vueTestUtils = require('vue-test-utils');

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var wrapper = null;
var options = {
  propsData: {
    mini: true,
    mode: 'md',
    color: 'danger'
  },
  slots: {
    default: '<span>Test</span>'
  }
};

describe('FabButton', function () {
  it('@base: renders the correct markup', function () {
    wrapper = (0, _vueTestUtils.mount)(_index2.default, options);
    var result = '<button mini="true" class="fab fab-md fab-md-danger fab-in-list fab-md-in-list"><i class="ion-icon fab-close-icon ion-ios-close"></i> <span class="button-inner"><span>Test</span></span></button>';
    expect(wrapper.html()).toEqual(result);
  });

  it('@base: component must have a name', function () {
    wrapper = (0, _vueTestUtils.mount)(_index2.default, options);
    expect(wrapper.name()).toEqual('FabButton');
  });

  it('@base: have the right className', function () {
    wrapper = (0, _vueTestUtils.mount)(_index2.default, options);
    expect(wrapper.hasClass('fab')).toBeTruthy();
  });
});