'use strict';

var _vueTestUtils = require('vue-test-utils');

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var wrapper = null;
var options = {
  propsData: {
    src: 'http://xx.xx.com/static/img/xx.png',
    alt: 'demo-img',
    width: 100,
    height: 200
  }
};

describe('Img', function () {
  it('@base: renders the correct markup', function () {
    wrapper = (0, _vueTestUtils.mount)(_index2.default, options);
    var result = '<div src="http://xx.xx.com/static/img/xx.png" class="ion-img img img-unloaded"><img alt="demo-img" style="display: none;" name="fade"></div>';
    expect(wrapper.html()).toEqual(result);
  });

  it('@base: component must have a name', function () {
    wrapper = (0, _vueTestUtils.mount)(_index2.default, options);
    expect(wrapper.name()).toEqual('Img');
  });

  it('@base: have the right className', function () {
    wrapper = (0, _vueTestUtils.mount)(_index2.default, options);
    expect(wrapper.hasClass('ion-img')).toBeTruthy();
  });
});