'use strict';

var _vueTestUtils = require('vue-test-utils');

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var wrapper = null;
var options = {
  propsData: {
    accordion: true
  },
  slots: {
    default: '<span>Test</span>'
  }
};

describe('ItemCollapseGroup', function () {
  it('@base: renders the correct markup', function () {
    wrapper = (0, _vueTestUtils.mount)(_index2.default, options);
    var result = '<div class="ion-item-collapse-group"><span>Test</span></div>';
    expect(wrapper.html()).toEqual(result);
  });

  it('@base: component must have a name', function () {
    wrapper = (0, _vueTestUtils.mount)(_index2.default, options);
    expect(wrapper.name()).toEqual('ItemCollapseGroup');
  });

  it('@base: have the right className', function () {
    wrapper = (0, _vueTestUtils.mount)(_index2.default, options);
    expect(wrapper.hasClass('ion-item-collapse-group')).toBeTruthy();
  });
});