'use strict';

var _vueTestUtils = require('vue-test-utils');

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var options = {
  propsData: {
    title: 'This is a title',
    mode: 'md',
    color: 'danger'
  },
  slots: {
    'item-right': '<span>item-right</span>',
    'item-left': '<span>item-left</span>',
    'item-title': '<span>item-title</span>',
    default: '<span>Test</span>'
  }
};

describe('ItemCollapse', function () {
  it('@base: renders the correct markup', function () {
    var wrapper = (0, _vueTestUtils.mount)(_index2.default, options);
    var result = '<div class="item-collapse collapse-md"><div class="ion-item item-block item-md item-md-danger"><span item-left="">item-left</span> <div class="item-inner"><div class="input-wrapper">This is a title</div> <div class="item-arrow"></div> <span item-right="">item-right</span></div></div> <div class="item-collapse-inner" style="display: none;"><span>Test</span></div></div>';
    expect(wrapper.html()).toEqual(result);
  });

  it('@base: component must have a name', function () {
    var wrapper = (0, _vueTestUtils.mount)(_index2.default, options);
    expect(wrapper.name()).toEqual('ItemCollapse');
  });

  it('@base: have the right className', function () {
    var wrapper = (0, _vueTestUtils.mount)(_index2.default, options);
    expect(wrapper.hasClass('collapse-md')).toBeTruthy();
  });
});