'use strict';

var _vueTestUtils = require('vue-test-utils');

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var options = {
  propsData: {
    mode: 'md',
    color: 'danger'
  }
};

describe('ItemDivider', function () {
  it('@base: renders the correct markup', function () {
    var wrapper = (0, _vueTestUtils.mount)(_index2.default, options);
    var result = '<div class="ion-item item-md ion-item-divider item-divider item-divider-md item-divider-md-danger"> <div class="item-inner"><div class="input-wrapper"></div> </div></div>';
    expect(wrapper.html()).toEqual(result);
  });

  it('@base: component must have a name', function () {
    var wrapper = (0, _vueTestUtils.mount)(_index2.default, options);
    expect(wrapper.name()).toEqual('ItemDivider');
  });

  it('@base: have the right className', function () {
    var wrapper = (0, _vueTestUtils.mount)(_index2.default, options);
    expect(wrapper.hasClass('ion-item-divider')).toBeTruthy();
  });
});