'use strict';

var _vueTestUtils = require('vue-test-utils');

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var options = {
  propsData: {
    mode: 'md',
    color: 'danger',
    fixed: true,
    floating: true,
    stacked: true
  },
  slots: {
    default: '<span>Test</span>'
  }
};

describe('Label', function () {
  it('@base: renders the correct markup', function () {
    var wrapper = (0, _vueTestUtils.mount)(_index2.default, options);
    var result = '<label fixed="true" floating="true" stacked="true" class="ion-label label label-md label-md-danger"><span>Test</span></label>';
    expect(wrapper.html()).toEqual(result);
  });

  it('@base: component must have a name', function () {
    var wrapper = (0, _vueTestUtils.mount)(_index2.default, options);
    expect(wrapper.name()).toEqual('Label');
  });

  it('@base: have the right className', function () {
    var wrapper = (0, _vueTestUtils.mount)(_index2.default, options);
    expect(wrapper.hasClass('ion-label')).toBeTruthy();
  });
});