'use strict';

var _vueTestUtils = require('vue-test-utils');

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var wrapper = null;
var opts = {
  slots: {
    default: '<span>Name</span>'
  },
  mocks: {
    $history: {
      getDirection: function getDirection() {
        return 'forward';
      }
    }
  }
};

describe('Page', function () {
  it('@base: renders the correct markup', function () {
    wrapper = (0, _vueTestUtils.mount)(_index2.default, opts);
    var result = '<article class="ion-page" style="z-index: 1001;"><span>Name</span></article>';
    expect(wrapper.html()).toEqual(result);
  });

  it('@base: component must have a name', function () {
    wrapper = (0, _vueTestUtils.mount)(_index2.default, opts);
    expect(wrapper.name()).toEqual('Page');
  });

  it('@base: renders the correct text', function () {
    wrapper = (0, _vueTestUtils.mount)(_index2.default, opts);
    expect(wrapper.text().trim()).toEqual('Name');
  });

  it('@base: z-index > 1000', function () {
    wrapper = (0, _vueTestUtils.mount)(_index2.default, opts);
    var zIndex = parseInt(wrapper.vm.$el.style.zIndex);
    expect(zIndex > 1000).toBeTruthy();
  });
});