'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = {
  core: {
    settings: {
      mode: 'ios'
    }
  },
  mobile: {
    settings: {
      mode: 'ios',
      imgRequestBuffer: 1400,
      imgRenderBuffer: 600,
      imgVelocityMax: 3
    }
  },
  android: {
    superset: 'mobile',
    subsets: [],
    settings: {
      toolbarMinHeight: 56,
      mode: 'md',
      backButtonText: '返回',
      backButtonIcon: 'icon-arrow-back',
      onPullIcon: 'icon-md-arrow-down',
      iconMode: 'md',
      menuType: 'overlay',
      spinner: 'crescent',
      scrollAssist: false,
      tabsHighlight: true,
      tabsPlacement: 'bottom',
      tabsHideOnSubPages: false,
      showIndicatorWhenPageChange: false,
      pageTransition: 'zoom-transition',
      pickerRotateFactor: 0,
      pickerScaleFactor: 0.81
    },
    isMatch: function isMatch(plt) {
      return plt.isPlatformMatch('android', ['android', 'silk'], ['windows phone']);
    },
    versionParser: function versionParser(plt) {
      return plt.matchUserAgentVersion(/Android (\d+).(\d+)?/);
    }
  },
  ios: {
    superset: 'mobile',
    subsets: [],
    settings: {
      toolbarMinHeight: 44,
      mode: 'ios',
      backButtonText: '返回',
      backButtonIcon: 'icon-arrow-back',
      onPullIcon: 'icon-ios-arrow-down',
      iconMode: 'ios',
      menuType: 'reveal',
      spinner: 'ios',
      scrollAssist: false,
      tabsHighlight: false,
      tabsPlacement: 'bottom',
      tabsHideOnSubPages: false,
      showIndicatorWhenPageChange: false,
      pageTransition: 'fade-right-transition',

      pickerRotateFactor: -0.46,
      pickerScaleFactor: 1
    },
    isMatch: function isMatch(plt) {
      return plt.isPlatformMatch('ios', ['iphone', 'ipad', 'ipod'], ['windows phone']);
    },
    versionParser: function versionParser(plt) {
      return plt.matchUserAgentVersion(/OS (\d+)_(\d+)?/);
    }
  }
};