'use strict';

var _regexp = require('../regexp');

var _regexp2 = _interopRequireDefault(_regexp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('regexp', function () {
  it('integer', function () {
    expect(_regexp2.default.integer.regexp.test(123)).toBeTruthy();
  });
  it('positiveInteger', function () {
    expect(_regexp2.default.positiveInteger.regexp.test(123)).toBeTruthy();
  });
  it('negativeInteger', function () {
    expect(_regexp2.default.negativeInteger.regexp.test(-1)).toBeTruthy();
  });
  it('email', function () {
    expect(_regexp2.default.email.regexp.test('123@163.com')).toBeTruthy();
  });
  it('ip', function () {
    expect(_regexp2.default.ip.regexp.test('255.255.255.255')).toBeTruthy();
  });
  it('idCard', function () {
    expect(_regexp2.default.idCard.regexp('112801199007153412')).toBeTruthy();
    expect(_regexp2.default.idCard.regexp('002801199007153412')).toBeFalsy();
    expect(_regexp2.default.idCard.regexp('0028011990071534')).toBeFalsy();
    expect(_regexp2.default.idCard.regexp('112801000000003412')).toBeFalsy();
    expect(_regexp2.default.idCard.regexp('112801199007153418')).toBeFalsy();
    expect(_regexp2.default.idCard.regexp('123')).toBeFalsy();
    expect(_regexp2.default.idCard.regexp('abc')).toBeFalsy();
    expect(_regexp2.default.idCard.regexp()).toBeFalsy();
  });
  it('password', function () {
    expect(_regexp2.default.password.regexp.test('avc123df')).toBeTruthy();
  });
  it('tel', function () {
    expect(_regexp2.default.tel.regexp.test('1234-1234567')).toBeTruthy();
    expect(_regexp2.default.tel.regexp.test('1234-12345678')).toBeTruthy();
    expect(_regexp2.default.tel.regexp.test('123-1234567')).toBeTruthy();
    expect(_regexp2.default.tel.regexp.test('123-12345678')).toBeTruthy();
    expect(_regexp2.default.tel.regexp.test('1234567')).toBeTruthy();
    expect(_regexp2.default.tel.regexp.test('12345678')).toBeTruthy();
  });
  it('mobile', function () {
    expect(_regexp2.default.mobile.regexp.test('18722221111')).toBeTruthy();
  });
  it('cn', function () {
    expect(_regexp2.default.cn.regexp.test('你好')).toBeTruthy();
  });
  it('securityCode', function () {
    expect(_regexp2.default.securityCode.regexp.test(1234)).toBeTruthy();
  });
  it('nickName', function () {
    expect(_regexp2.default.nickName.regexp.test('ABC23你好')).toBeTruthy();
  });
  it('qq', function () {
    expect(_regexp2.default.qq.regexp.test('1233221')).toBeTruthy();
  });
  it('url', function () {
    expect(_regexp2.default.url.regexp.test('http://xxx.xx.xx')).toBeTruthy();
  });
});