'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CssGenerate = function () {
  function CssGenerate() {
    _classCallCheck(this, CssGenerate);

    this.css = {
      transform: null,
      transition: null,
      transitionDuration: null,
      transitionDelay: null,
      transitionTimingFn: null,
      transitionStart: null,
      transitionEnd: null,
      transformOrigin: null,
      animationDelay: null
    };

    if (!this.css.transform) {
      return this.getCss();
    } else {
      return this.css;
    }
  }

  _createClass(CssGenerate, [{
    key: 'getCss',
    value: function getCss() {
      var docEle = document.documentElement;
      var css = this.css;

      var i;
      var keys = ['webkitTransform', '-webkit-transform', 'webkit-transform', 'transform'];

      for (i = 0; i < keys.length; i++) {
        if (docEle.style[keys[i]] !== undefined) {
          css.transform = keys[i];
          break;
        }
      }

      keys = ['webkitTransition', 'transition'];
      for (i = 0; i < keys.length; i++) {
        if (docEle.style[keys[i]] !== undefined) {
          css.transition = keys[i];
          break;
        }
      }

      var isWebkit = css.transition.indexOf('webkit') > -1;

      css.transitionDuration = (isWebkit ? '-webkit-' : '') + 'transition-duration';

      css.transitionTimingFn = (isWebkit ? '-webkit-' : '') + 'transition-timing-function';

      css.transitionDelay = (isWebkit ? '-webkit-' : '') + 'transition-delay';

      css.transitionEnd = (isWebkit ? 'webkitTransitionEnd ' : '') + 'transitionend';

      css.transformOrigin = (isWebkit ? '-webkit-' : '') + 'transform-origin';

      css.animationDelay = isWebkit ? 'webkitAnimationDelay' : 'animationDelay';
      return css;
    }
  }]);

  return CssGenerate;
}();

exports.default = new CssGenerate();